(function () {
    'use strict';

    var platform = 'mssql';

    function restorePlatform() {

        var lastPlatform = window.localStorage.getItem('platform');

        if (!lastPlatform) return;

        if (lastPlatform == platform) return;

        var elements = document.querySelectorAll('input[type="radio"][name="platform"]');

        for (var i = 0; i < elements.length; i++) {
            if (elements[i].value == lastPlatform) {
                elements[i].checked = true;
                changePlatform(lastPlatform);
                break;
            }
        }
    }

    function addListeners() {

        var url = window.location.href;
        var isOnline = url.indexOf('.savetodb.com') > 0;

        var elements = document.querySelectorAll('input[type="radio"][name="platform"]');

        for (var i = 0; i < elements.length; i++) {
            var value = elements[i].value;
            if (isOnline && (value == 'oracle' || value == 'db2' || value == 'nuodb')) {
                elements[i].setAttribute('disabled', '');
                elements[i].title = 'You can test it in your environment';
            }
            elements[i].addEventListener('change', onChangePlatform);
        }
    }

    function onChangePlatform(event) {

        var value = event.target.value;

        event.stopPropagation();

        changePlatform(value);
    }

    function changePlatform(value) {

        if (!value)
            return;

        var elements = document.querySelectorAll('a[href].mp');

        var searchValue = '/' + platform + '-';
        var replaceValue = '/' + value + '-';

        for (var i = 0; i < elements.length; i++) {

            var element = elements[i];

            if (element.classList.contains('mp')) {

                element.href = element.href.replace(searchValue, replaceValue);

                element.innerHTML = element.innerHTML.replace(searchValue, replaceValue);
            }
        }

        elements = document.querySelectorAll('div[data-url].odatadb-control.mp');

        for (var i = 0; i < elements.length; i++) {

            var element = elements[i];

            var attr = element.getAttribute('data-url');

            if (attr)
                element.setAttribute('data-url', attr.replace(searchValue, replaceValue));
        }

        elements = document.querySelectorAll('select[data-api-root].odatadb-object-list');

        for (var i = 0; i < elements.length; i++) {

            var element = elements[i];

            var attr = element.getAttribute('data-api-root');

            if (attr)
                element.setAttribute('data-api-root', attr.replace(searchValue, replaceValue));
        }

        platform = value;

        window.localStorage.setItem('platform', platform);
    }

    restorePlatform();
    addListeners();

}());
